<template>
	<view class="main">
		<view class="one">
			<tabs :tabs="tabs" @tabsChange="tabsChange">
				<view class="tabsList">
					<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage" @scroll="toScroll">
						<view class="list-scroll-view">
							<!-- 瀑布流布局列表 -->
							<view class="pubuBox">
								<view class="pubuItem">
									<view class="list" v-for="(item, index) in list" :key="index" @tap="toInfo(item)">
										<image v-if="item.file.length>0" :src="item.file&&item.file.length>0?item.file[0].url:''" mode="widthFix">
										</image>
										<image v-else :src="config.file&&config.file.length>0?config.file[0].url:''" mode="widthFix">
										</image>
										<view class="title"> <!-- 这是没有高度的父盒子（下半部分） -->
											<view class="title_1">{{ item.title ||item.name||'暂无'}}</view>
											<view class="title_2">
												<view class="left textOver">
													{{item.contact_name||item.address||'暂无'}}
												</view>
												<view class="right" @tap.stop="toLike(item)">
													<text class="iconfont icon-shoucang"></text>
													{{item.collect_num||'0'}}
												</view>
											</view>
										</view>
									</view>
								</view>
							</view>
							<view class="is_bottom" v-if="is_bottom">
								<text>{{config.bottom_title||'到底了！'}}</text>
							</view>
						</view>
					</scroll-view>
				</view>
			</tabs>
		</view>
	</view>
</template>

<script>
	import tabs from '../../components/tabs/index.vue';
	export default {
		components: {
			tabs
		},
		data() {
			return {
				config: {},
				user: {},
				tabs: {
					active: 'article',
					bgColor: '#ffffff',
					menu: [{
							title: '游玩攻略',
							active: 'article'
						},
						{
							title: '酒店民宿',
							active: 'hotel'
						},
						{
							title: '美食特色',
							active: 'location'
						},
						{
							title: '景区门票',
							active: 'ticket'
						}
					]
				},
				list: [],
				total: 0,
				skip: 0,
				limit: 6,
				page: 0,
				// 数据是否触底
				is_bottom: false,
				scrollTop: 0,
			}
		},
		onLoad: async function(e) {
			const that = this;
			that.searchToken();
			that.searchConfig();
		},
		onShow: async function() {
			const that = this;
			that.clearPage();
			await that.search();
		},
		onPullDownRefresh: async function() {
			const that = this;
			that.clearPage();
			await that.search();
			uni.stopPullDownRefresh();
		},
		methods: {
			searchToken() {
				const that = this;
				try {
					const res = uni.getStorageSync('token');
					if (res) that.$set(that, `user`, res);
				} catch (e) {
					uni.showToast({
						title: err.errmsg,
						icon: 'error',
						duration: 2000
					});
				}
			},
			searchConfig() {
				const that = this;
				try {
					const res = uni.getStorageSync('config');
					if (res) that.$set(that, `config`, res);
				} catch (e) {
					uni.showToast({
						title: err.errmsg,
						icon: 'error',
						duration: 2000
					});
				}
			},
			async search() {
				const that = this;
				if (!that.user._id) return
				let info = {
					skip: that.skip,
					limit: that.limit,
					user: that.user._id,
					source_type: that.tabs.active,
					type: '1'
				}
				const res = await that.$api(`/like/article`, 'GET', {
					...info,
					...that.searchInfo
				})
				if (res.errcode == '0') {
					let list = [...that.list, ...res.data];
					that.$set(that, `list`, list)
					that.$set(that, `total`, res.total)
				} else {
					uni.showToast({
						title: res.errmsg,
					});
				}
			},
			// 选择选项卡
			tabsChange(e) {
				const that = this;
				that.$set(that.tabs, `active`, e.active)
				that.clearPage();
				that.search()
			},
			// 查看详情
			toInfo(item) {
				const that = this;
				if (that.tabs.active == 'article') {
					uni.navigateTo({
						url: `/pagesHome/article/index?id=${item.id||item._id}`
					})
				} else if (that.tabs.active == 'hotel') {
					uni.navigateTo({
						url: `/pagesHome/hotel/info?id=${item.id||item._id}`
					})
				} else if (that.tabs.active == 'location') {
					uni.navigateTo({
						url: `/pagesHome/type/info?id=${item.id||item._id}`
					})
				} else if (that.tabs.active == 'ticket') {
					uni.navigateTo({
						url: `/pagesHome/ticket/info?id=${item.id||item._id}`
					})
				}
			},
			// 取消收藏
			async toLike(item) {
				const that = this;
				let res;
				res = await that.$api(`/like/${item.collect}`, 'DELETE', {})
				if (res.errcode == '0') {
					that.clearPage();
					that.search()
				}
			},
			// 分页
			toPage(e) {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();
				} else that.$set(that, `is_bottom`, true)
			},
			toScroll(e) {
				const that = this;
				let up = that.scrollTop;
				that.$set(that, `scrollTop`, e.detail.scrollTop);
				let num = Math.sign(up - e.detail.scrollTop);
				if (num == 1) that.$set(that, `is_bottom`, false);
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 6)
				that.$set(that, `page`, 0)
			}
		}
	}
</script>

<style lang="scss" scoped>
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			position: relative;
			flex-grow: 1;
			background-color: var(--f9Color);
			margin: 2vw 0 0 0;

			.tabsList {
				position: relative;
				width: 100vw;
				height: 90vh;

				.pubuBox {
					padding: 2vw;
				}

				.pubuItem {
					column-count: 2;
					column-gap: 2vw;
				}

				.list {
					box-sizing: border-box;
					border-radius: 2vw;
					overflow: hidden;
					background-color: var(--mainColor);
					break-inside: avoid;
					/*避免在元素内部插入分页符*/
					box-sizing: border-box;
					margin-bottom: 2vw;
				}

				.list image {
					width: 100%;
				}

				.title {
					padding: 2vw;

					.title_1 {
						font-size: var(--font14Size);
						line-height: 4.5vw;
						text-overflow: -o-ellipsis-lastline;
						overflow: hidden;
						text-overflow: ellipsis;
						display: -webkit-box;
						-webkit-line-clamp: 2;
						line-clamp: 2;
						-webkit-box-orient: vertical;
						min-height: 6vw;
						max-height: 20vw;
					}

					.title_2 {
						display: flex;
						justify-content: space-between;
						font-size: var(--font12Size);
						color: var(--f69Color);
						padding: 1vw 0;

						.right {
							display: flex;
							align-items: center;

							text:first-child {
								padding: 0 1vw 0 0;
							}
						}
					}
				}
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		width: 100%;
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: var(--f85Color);
			font-size: var(--font14Size);
		}
	}
</style>